<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.5"/>
<title>Advanced Cuts for Cooperative OPF: decoop::PriceProblem Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">Advanced Cuts for Cooperative OPF
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.5 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Namespaces</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Friends</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(9)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacedecoop.html">decoop</a></li><li class="navelem"><a class="el" href="classdecoop_1_1_price_problem.html">PriceProblem</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="classdecoop_1_1_price_problem-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">decoop::PriceProblem Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Class used to compute prices at each bus and congestion cost.  
 <a href="classdecoop_1_1_price_problem.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="coop_benders_algorithm_8hpp_source.html">coopBendersAlgorithm.hpp</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:aad9dac4ba44148d0a7f9cc632f000634"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_price_problem.html#aad9dac4ba44148d0a7f9cc632f000634">PriceProblem</a> (const std::string &amp;lp_file, const std::vector&lt; std::pair&lt; int, double &gt;&gt; &amp;plantbusses, const unsigned timesteps, const double sbase)</td></tr>
<tr class="memdesc:aad9dac4ba44148d0a7f9cc632f000634"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor.  <a href="#aad9dac4ba44148d0a7f9cc632f000634">More...</a><br/></td></tr>
<tr class="separator:aad9dac4ba44148d0a7f9cc632f000634"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a047cfe9673eaa2e1182bf0c1efb969b7"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_price_problem.html#a047cfe9673eaa2e1182bf0c1efb969b7">ComputePrices</a> (const std::unordered_map&lt; int, double &gt; &amp;bus_data, const std::unordered_map&lt; std::string, double &gt; &amp;wd, GRBModel &amp;loadflow_in)</td></tr>
<tr class="memdesc:a047cfe9673eaa2e1182bf0c1efb969b7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Computes electricity prices as locational marginal cost at each bus.  <a href="#a047cfe9673eaa2e1182bf0c1efb969b7">More...</a><br/></td></tr>
<tr class="separator:a047cfe9673eaa2e1182bf0c1efb969b7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1f4640f81b1c48a07adca7278d16ff79"><td class="memItemLeft" align="right" valign="top">std::vector&lt; std::vector<br class="typebreak"/>
&lt; double &gt; &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_price_problem.html#a1f4640f81b1c48a07adca7278d16ff79">GetPrices</a> ()</td></tr>
<tr class="memdesc:a1f4640f81b1c48a07adca7278d16ff79"><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets previously computed electricity prices at each bus.  <a href="#a1f4640f81b1c48a07adca7278d16ff79">More...</a><br/></td></tr>
<tr class="separator:a1f4640f81b1c48a07adca7278d16ff79"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a672a45fd289487496972167b1b55f7f9"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_price_problem.html#a672a45fd289487496972167b1b55f7f9">ComputeAndPrintCongestionCost</a> (std::ofstream &amp;out_file, std::string &amp;&amp;setup)</td></tr>
<tr class="memdesc:a672a45fd289487496972167b1b55f7f9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Computes congestion cost and writes congested lines to specified file.  <a href="#a672a45fd289487496972167b1b55f7f9">More...</a><br/></td></tr>
<tr class="separator:a672a45fd289487496972167b1b55f7f9"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:a3a2a06aa945eaaadaa80a814bd8187ce"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a3a2a06aa945eaaadaa80a814bd8187ce"></a>
GRBEnv&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_price_problem.html#a3a2a06aa945eaaadaa80a814bd8187ce">price_env_</a></td></tr>
<tr class="memdesc:a3a2a06aa945eaaadaa80a814bd8187ce"><td class="mdescLeft">&#160;</td><td class="mdescRight">Environment for model. <br/></td></tr>
<tr class="separator:a3a2a06aa945eaaadaa80a814bd8187ce"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a33a5b2ffb50f97497c031fa742e7a1d3"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a33a5b2ffb50f97497c031fa742e7a1d3"></a>
GRBModel&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_price_problem.html#a33a5b2ffb50f97497c031fa742e7a1d3">loadflow_price_</a></td></tr>
<tr class="memdesc:a33a5b2ffb50f97497c031fa742e7a1d3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Model used to compute prices. <br/></td></tr>
<tr class="separator:a33a5b2ffb50f97497c031fa742e7a1d3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8a4e0ef0a28b311a50ed9d42c9a24b5e"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a8a4e0ef0a28b311a50ed9d42c9a24b5e"></a>
<a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html">DynArrayRAIIWrapper</a>&lt; GRBVar &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_price_problem.html#a8a4e0ef0a28b311a50ed9d42c9a24b5e">price_vars_</a></td></tr>
<tr class="memdesc:a8a4e0ef0a28b311a50ed9d42c9a24b5e"><td class="mdescLeft">&#160;</td><td class="mdescRight">All variables contained in the model <a class="el" href="classdecoop_1_1_price_problem.html#a33a5b2ffb50f97497c031fa742e7a1d3" title="Model used to compute prices. ">loadflow_price_</a>. <br/></td></tr>
<tr class="separator:a8a4e0ef0a28b311a50ed9d42c9a24b5e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3fbdc2d0f7bdfb301539ca6cde9dd891"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a3fbdc2d0f7bdfb301539ca6cde9dd891"></a>
std::vector&lt; std::pair&lt; int, <br class="typebreak"/>
double &gt; &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_price_problem.html#a3fbdc2d0f7bdfb301539ca6cde9dd891">plantbusses_</a></td></tr>
<tr class="memdesc:a3fbdc2d0f7bdfb301539ca6cde9dd891"><td class="mdescLeft">&#160;</td><td class="mdescRight">Contains bus numbers of cooperating busses as well as flexible load fractions. <br/></td></tr>
<tr class="separator:a3fbdc2d0f7bdfb301539ca6cde9dd891"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad4bebc3c8d302de0ac70da6ac1f5f61d"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ad4bebc3c8d302de0ac70da6ac1f5f61d"></a>
unsigned&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_price_problem.html#ad4bebc3c8d302de0ac70da6ac1f5f61d">timesteps_</a></td></tr>
<tr class="memdesc:ad4bebc3c8d302de0ac70da6ac1f5f61d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Number of timesteps in the model. <br/></td></tr>
<tr class="separator:ad4bebc3c8d302de0ac70da6ac1f5f61d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1087bd9f6bb169778232ec7f8d634b7b"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a1087bd9f6bb169778232ec7f8d634b7b"></a>
double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_price_problem.html#a1087bd9f6bb169778232ec7f8d634b7b">sbase_</a></td></tr>
<tr class="memdesc:a1087bd9f6bb169778232ec7f8d634b7b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Per-unit base. <br/></td></tr>
<tr class="separator:a1087bd9f6bb169778232ec7f8d634b7b"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Class used to compute prices at each bus and congestion cost. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="aad9dac4ba44148d0a7f9cc632f000634"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">decoop::PriceProblem::PriceProblem </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>lp_file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::vector&lt; std::pair&lt; int, double &gt;&gt; &amp;&#160;</td>
          <td class="paramname"><em>plantbusses</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const unsigned&#160;</td>
          <td class="paramname"><em>timesteps</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const double&#160;</td>
          <td class="paramname"><em>sbase</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Constructor. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">lp_file</td><td>Name of the LP file from which to build the <a class="el" href="classdecoop_1_1_price_problem.html#a33a5b2ffb50f97497c031fa742e7a1d3" title="Model used to compute prices. ">loadflow_price_</a> model. </td></tr>
    <tr><td class="paramname">plantbusses</td><td>Contains bus numbers of cooperating busses as well as flexible load fractions. </td></tr>
    <tr><td class="paramname">timesteps</td><td>Number of timesteps in the model. </td></tr>
    <tr><td class="paramname">sbase</td><td>Per-unit base. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a672a45fd289487496972167b1b55f7f9"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double decoop::PriceProblem::ComputeAndPrintCongestionCost </td>
          <td>(</td>
          <td class="paramtype">std::ofstream &amp;&#160;</td>
          <td class="paramname"><em>out_file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::string &amp;&amp;&#160;</td>
          <td class="paramname"><em>setup</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Computes congestion cost and writes congested lines to specified file. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">out_file</td><td>Reference to file object to write output to. </td></tr>
    <tr><td class="paramname">setup</td><td>Describes what setup is being run (eg nominal, integrated, disaggregated). </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Congestion cost. </dd></dl>

</div>
</div>
<a class="anchor" id="a047cfe9673eaa2e1182bf0c1efb969b7"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void decoop::PriceProblem::ComputePrices </td>
          <td>(</td>
          <td class="paramtype">const std::unordered_map&lt; int, double &gt; &amp;&#160;</td>
          <td class="paramname"><em>bus_data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::unordered_map&lt; std::string, double &gt; &amp;&#160;</td>
          <td class="paramname"><em>wd</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">GRBModel &amp;&#160;</td>
          <td class="paramname"><em>loadflow_in</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Computes electricity prices as locational marginal cost at each bus. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">bus_data</td><td>Nominal power draw of all busses with loads, in MW. </td></tr>
    <tr><td class="paramname">wd</td><td>power supply pattern of wind farms and non-cooperative load pattern, both over all time steps </td></tr>
    <tr><td class="paramname">loadflow_in</td><td>Reference to solved OPF model whose power flow is to be used for computations. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a1f4640f81b1c48a07adca7278d16ff79"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt; std::vector&lt; double &gt; &gt; decoop::PriceProblem::GetPrices </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Gets previously computed electricity prices at each bus. </p>
<p>The outer vector contains an entry for each plantbus. The inner vector contains an entry for each timestep on that plantbus. The order of plantbusses follows the order in which they are specified in the option file. </p>
<dl class="section return"><dt>Returns</dt><dd>Vector containing vectors of prices on each bus. </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>inc/<a class="el" href="coop_benders_algorithm_8hpp_source.html">coopBendersAlgorithm.hpp</a></li>
<li>src/<a class="el" href="coop_benders_algorithm_8cpp.html">coopBendersAlgorithm.cpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.5
</small></address>
</body>
</html>
